<template>
    <div class="container">
        <h1>{{ channelName }}</h1>
        <div class="info">
            <div>
                <p>!join</p>
                <h4>Type</h4>
            </div>
            <div class="button" @click="startGame">
                <p>Start</p>
                <img src="/Arrow.svg" />
            </div>
        </div>
        <div class="sidepanel">
            <Info label="Players" :value="players.length"></Info>
            <hr />
            <ul>
                <li v-for="player in recentPlayer" :key="player.username">
                    {{ player.displayName }}
                </li>
            </ul>
        </div>
    </div>
</template>

<script>
import tmi from 'tmi.js'
import { mapState } from 'vuex'
import Info from '~/components/info'

export default {
    name: 'Join',
    components: {
        Info,
    },
    data() {
        return {
            players: [],
        }
    },
    computed: {
        ...mapState(['channelName']),
        recentPlayer() {
            return [...this.players].reverse().slice(0, 24)
        },
    },
    watch: {
        channelName() {
            this.players = []
        },
    },
    mounted() {
        if (!this.channelName) this.$router.push('/')
        const client = new tmi.Client({
            connection: {
                secure: true,
                reconnect: true,
            },
            channels: [this.channelName],
        })

        client.connect()

        client.on('message', (channel, tags, message, self) => {
            if (message.startsWith('!join')) {
                if (
                    this.players.findIndex(
                        (p) => p.username === tags.username
                    ) !== -1
                )
                    return
                this.players.push({
                    username: tags.username,
                    score: 0,
                    displayName: tags['display-name'],
                })
            }
        })
    },
    methods: {
        startGame() {
            this.$store.commit('setPlayers', this.players)
            this.$router.push('/Game')
        },
    },
}
</script>

<style scoped>
.container {
    margin: 0 auto;
    min-height: 100vh;
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
}

.info {
    display: flex;
    justify-content: space-evenly;
    flex-direction: column;
    height: 100vh;
    padding: 100px;
    text-align: left;
}

.right {
    position: absolute;
    padding: 40px;
    right: 0;
    top: 0;
    bottom: 100px;
    width: 40vw;
}

hr {
    margin: 1em 0;
    opacity: 0.4;
}

ul {
    text-align: right;
    list-style: none;
    padding: 0;
}

li {
    font-weight: 800;
    font-size: 36px;
    color: #cdcdcd;
}

img {
    margin-top: 4px;
    margin-left: 1em;
    height: 1.4em;
}
</style>
